MountRandomMount = LibStub("AceAddon-3.0"):NewAddon("MountRandomMount", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("MountRandomMount")
MountRandomMount_SavedTable = { }
MountRandomMount_SavedTable.randommountlist = {  }
MountRandomMount_SeaTurtleIHave = false
MountRandomMount_SeaTurtleID = 0
MountRandomMount_SeaTurtleIRealID = 0
MountRandomMount_CheckedForST = false
MRM_Mainpanel = ""
MountRandomMount.btn = CreateFrame("Button", "MRMSecureButton", UIParent, "SecureActionButtonTemplate");
local bind1, bind2
MountRandomMount_SavedTable.MRMDruid_CatInside = false
local found1 = false
local found2 = false
local MRMDebug = false
local MRM_Zones = {}

SLASH_RELOADUI1 = "/rl"
SlashCmdList.RELOADUI = ReloadUI

function MountRandomMount:MountRandom()
	if (MountRandomMount_SavedTable == nil)
		or ((MountRandomMount_SavedTable['flying'] == nil) and (MountRandomMount_SavedTable['ground'] == nil))
		or ((#MountRandomMount_SavedTable['flying'] == 0) and(#MountRandomMount_SavedTable['ground'] == 0)) then
		print(L['MRMNoMounts'])
		return
	end
	if CanExitVehicle() then
		VehicleExit()
	elseif IsMounted() then
		Dismount()
		return
	end

	local fly = MountRandomMount:Flying()
	local mountSummoned

	if fly then
		if MountRandomMount_SavedTable['flying'] == nil or #MountRandomMount_SavedTable['flying'] == 0 then
			if MountRandomMount_SavedTable['ground'] == nil or #MountRandomMount_SavedTable['ground'] == 0 then
				print(L['MRMNoMounts'])
				return
			else
				print(L['MRMNoFlyingMountsLand'])
				mountSummoned = MountRandomMount_SavedTable['ground'][(random(#MountRandomMount_SavedTable['ground']))]
				if MRMDebug then
					print("The summoned mount is: "..mountSummoned)
				end
				C_MountJournal.SummonByID(mountSummoned)
				return
			end
		end
		mountSummoned = MountRandomMount_SavedTable['flying'][(random(#MountRandomMount_SavedTable['flying']))]
		if MRMDebug then
			print("The summoned mount is: "..mountSummoned)
		end
		C_MountJournal.SummonByID(mountSummoned)
	else
		if(IsSwimming()) then
			SetMapToCurrentZone()
			local continent = GetCurrentMapContinent()
			local zones = {GetMapZones(continent)}
			local zone = GetCurrentMapZone()
			if continent == 2 and ( zones[zone] == L['MRMKelp'] or zones[zone] == L['MRMShimExp'] or zones[zone] == L['MRMAbysDepth']) then
				if MountRandomMount_SeaHorseHave then
					local SeaTurtle = MountRandomMount_SeaHorseID
					C_MountJournal.SummonByID(SeaTurtle)
					return
				else
					print("You don't have a swimming mount, calling random land mount.")
					if MountRandomMount_SavedTable['ground'] == nil or #MountRandomMount_SavedTable['ground'] == 0 then
						print(L['MRMNoMounts'])
						return
					else
						mountSummoned = MountRandomMount_SavedTable['ground'][(random(#MountRandomMount_SavedTable['ground']))]
						if MRMDebug then
							print("The summoned mount is: "..mountSummoned)
						end
						C_MountJournal.SummonByID(mountSummoned)
						return
					end
				end
			else
				if MountRandomMount_SeaTurtleHave then
					local SeaTurtle = MountRandomMount_SeaTurtleID
					C_MountJournal.SummonByID(mountSummoned)
					return
				else
					print("You don't have a swimming mount, calling random land mount.")
					if MountRandomMount_SavedTable['ground'] == nil or #MountRandomMount_SavedTable['ground'] == 0 then
						print(L['MRMNoMounts'])
						return
					else
						mountSummoned = MountRandomMount_SavedTable['ground'][(random(#MountRandomMount_SavedTable['ground']))]
						if MRMDebug then
							print("The summoned mount is: "..mountSummoned)
						end
						C_MountJournal.SummonByID(mountSummoned)
						return
					end
				end
			end
		else
			MountRandomMount:LandOnly()
		end
	end

end

function MountRandomMount:Flying()
	--get breath status
	local timer, initial, maxvalue, scale = GetMirrorTimerInfo(2)
	if timer == "BREATH" and scale == -1 then
		return false
	end

	SetMapToCurrentZone()
	local continent = GetCurrentMapContinent()
	local zones = {GetMapZones(continent)}
	local zone = GetCurrentMapZone()
	if continent == 2 and ( zones[zone] == L['MRMKelp'] or zones[zone] == L['MRMShimExp'] or zones[zone] == L['MRMAbysDepth']) then
		if MountRandomMount_SeaHorseHave then
			return false
		end
	end

	if continent ~= 7 and continent ~= -1 and IsFlyableArea() then
		return true
	else
		return false
	end
end

function MountRandomMount:LandOnly()
	local mountSummoned
	if MountRandomMount_SavedTable == nil
	or (
	(MountRandomMount_SavedTable['ground'] == nil or #MountRandomMount_SavedTable['ground'] == 0)
	and (MountRandomMount_SavedTable['enableFlyEverywere'] == false or (MountRandomMount_SavedTable['flying'] == nil or #MountRandomMount_SavedTable['flying'] == 0))) then
		print(L['MRMNoMounts'])
		return
	end
	if CanExitVehicle() then
		VehicleExit()
	elseif IsMounted() then
		Dismount()
		return
	end
	if MountRandomMount_SavedTable['enableFlyEverywere'] == true and (math.random(0, 1) == 1 or #MountRandomMount_SavedTable['ground'] == 0) then
		mountSummoned = MountRandomMount_SavedTable['flying'][(random(#MountRandomMount_SavedTable['flying']))]
	else
		mountSummoned = MountRandomMount_SavedTable['ground'][(random(#MountRandomMount_SavedTable['ground']))]
	end

	if MRMDebug then
		print("The summoned mount is: "..mountSummoned)
	end
	C_MountJournal.SummonByID(mountSummoned)
end

function MountRandomMount:OnPostClick()
	if MRMDebug then
		print("hit post click")
	end
	MountRandomMount.btn:SetAttribute("spell", nil)
end

function MountRandomMount:TravelForm(localizedClass, localizedRace)
	if MRMDebug then
		print("keybinding xfering to secure button hit")
	end
	found1= false
	found2= false
	local kk1 =0
	local kk2 = 0
	MountRandomMount.btn:SetAttribute("type", "spell")
	MountRandomMount.btn:SetScript(
		"PreClick",
		function()
			MountRandomMount:OnPreClick()
		end
	)
	MountRandomMount.btn:SetScript(
		"PostClick",
		function()
			MountRandomMount:OnPostClick()
		end
	)
	MountRandomMount.btn:SetAttribute("spell", nil)
	for k = 1, GetNumBindings(), 1 do
		local command, key1, key2 = GetBinding(k);
		if command and command == "MRMTravelTRIGGER" then
			if key1 then
				if MRMDebug then
					print("key binding 1 is: "..key1)
				end
				bind1 = key1
				local success = SetBindingClick(bind1, "MRMSecureButton")
				if MRMDebug then
					if success then
						print("key binding 1 was successfully bound.")
					else
						print("key binding 1 was NOT successfully bound.")
					end
				end
			end
			if (key2) then
				if MRMDebug then
					print("key binding 2 is: "..key2)
				end
				bind2 = key2
				local success = SetBindingClick(bind2, "MRMSecureButton")
				if MRMDebug then
					if success then
						print("key binding 1 was successfully bound.")
					else
						print("key binding 1 was NOT successfully bound.")
					end
				end
			end
		end
	end
end

function MountRandomMount:OnPreClick()
	if MRMDebug then
		print("pre click hit")
	end
	local localizedClass, englishClass = UnitClass("player")
	local localizedRace, raceEn = UnitRace("player")
	if localizedClass == L['MRMShaman'] or localizedClass == L['MRMShamanF'] then
		local name2 = GetSpellInfo(2645)
		local name = GetSpellInfo(name2)
		if name ~= nil then
			MountRandomMount.btn:SetAttribute("spell", name)
		else
			print(L['MRMGhostWolf'])
		end


	elseif localizedClass == L['MRMDruid'] then
		local isInstance, instanceType = IsInInstance()
		local inside = IsIndoors()
		if IsSwimming() then
			local name2 = GetSpellInfo(1066)--Aquatic Form
			local name = GetSpellInfo(name2)
			if name ~= nil then
				MountRandomMount.btn:SetAttribute("spell", name)
			else
				print(L['MRMAcquaForm'])
			end
		elseif (inside ~= nil or isInstance ~= nil) and MountRandomMount_SavedTable.MRMDruid_CatInside == true then
			local name2 = GetSpellInfo(768)--Cat Form
			local name = GetSpellInfo(name2)
			if name ~= nil then
				MountRandomMount.btn:SetAttribute("spell", name)
			else
				print(L['MRMCatForm'])
			end
		elseif not IsFlyableArea() then
			if localizedRace == L['MRMWorgen'] then
				local name2 = GetSpellInfo(87840)--Running Wild
				local name = GetSpellInfo(name2)
				if name ~= nil then
					MountRandomMount.btn:SetAttribute("spell", name)
				else
					print(L['MRMRunningWild'])
				end
			else
				local name2 = GetSpellInfo(783)--Travel Form
				local name = GetSpellInfo(name2)
				if name ~= nil then
					MountRandomMount.btn:SetAttribute("spell", name)
				else
					print(L['MRMTravelForm'])
				end
			end
		else
			local fly = MountRandomMount:Flying()
			if fly then
				local name2 = GetSpellInfo(40120)--Swift Flight Form
				local name = GetSpellInfo(name2)
				if name ~= nil then
					MountRandomMount.btn:SetAttribute("spell", name)
				else
					name2 = GetSpellInfo(33943)--Flight Form
					name = GetSpellInfo(name2)
					if name ~= nil then
						MountRandomMount.btn:SetAttribute("spell", name)
					else
						name2 = GetSpellInfo(783)--Travel Form
						name = GetSpellInfo(name2)
						if name ~= nil then
							MountRandomMount.btn:SetAttribute("spell", name)
						else
							print(MRMFlighForm)
						end
					end
				end
			else
				if localizedRace == L['MRMWorgen'] then
					local name2 = GetSpellInfo(87840)--Running Wild
					local name = GetSpellInfo(name2)
					if name ~= nil then
						MountRandomMount.btn:SetAttribute("spell", name)
					else
						print(L['MRMRunningWild'])
					end
				else
					local name2 = GetSpellInfo(783)--Travel Form
					local name = GetSpellInfo(name2)
					if name ~= nil then
						MountRandomMount.btn:SetAttribute("spell", name)
					else
						print(L['MRMTravelForm'])
					end
				end
			end
		end
	elseif (localizedRace == L['MRMWorgen']) then
		local name2 = GetSpellInfo(87840)--Running Wild
		local name = GetSpellInfo(name2)
		if name ~= nil then
			MountRandomMount.btn:SetAttribute("spell", name)
		else
			print(L['MRMRunningWild'])
		end
	end
end

function MountRandomMount:add(amount)
	amount = string.lower(amount)
	local foundmount = false
	local insert = false
	local mountcount = GetNumCompanions("MOUNT")
	local mntspid, _, creatureName, creatureSpellID, sources, mounts
	for i = 1, mountcount do
		_, creatureName, creatureSpellID = GetCompanionInfo("MOUNT", i)
		local lowerCN = string.lower(creatureName)
		if amount == lowerCN then
			foundmount = true
			mntspid = creatureSpellID
			break
		end
	end
	if foundmount == true then
		for _, mounts in pairs(MountRandomMount_MountDataList["flying"]) do
			for _, v in pairs(mounts) do
				if mntspid == v then
					insert = true
					for _, vSaved in pairs(MountRandomMount_SavedTable['flying']) do
						if vSaved == v then
							insert = false
							break
						end
					end
					break
				end
			end
		end
		if insert then
			print(amount.." "..L['MRMFlyingAdded'])
			table.insert(MountRandomMount_SavedTable['flying'], mntspid)
			insert = false
		end
		for _, mounts in pairs(MountRandomMount_MountDataList["ground"]) do
			for _, v in pairs(mounts) do
				if mntspid == v then
					insert = true
					for _, vSaved in pairs(MountRandomMount_SavedTable['ground']) do
						if vSaved == v then
							insert = false
							break
						end
					end
					break
				end
			end
		end
		if insert then
			print(amount.." "..L['MRMLandAdded'])
			table.insert(MountRandomMount_SavedTable['ground'], mntspid)
		end
	end
end

function MountRandomMount:remove(amount)
	for iSaved, vSaved in pairs(MountRandomMount_SavedTable['ground']) do
		if amount == string.lower(GetSpellInfo(vSaved)) then
			print(amount.." "..L['MRMLandRemoved'])
			table.remove(MountRandomMount_SavedTable['ground'], iSaved)
			break
		end
	end
	for iSaved, vSaved in pairs(MountRandomMount_SavedTable['flying']) do
		if amount == string.lower(GetSpellInfo(vSaved)) then
			print(amount.." "..L['MRMFlyingRemoved'])
			table.remove(MountRandomMount_SavedTable['flying'], iSaved)
			break
		end
	end
end

function MountRandomMount:list()
	if MountRandomMount_SavedTable == nil
			or (MountRandomMount_SavedTable['flying'] == nil and MountRandomMount_SavedTable['ground'] == nil)
			or (#MountRandomMount_SavedTable['flying'] == 0 and #MountRandomMount_SavedTable['ground'] == 0) then
		print(L['MRMNoMounts'])
		return
	end
	print(L['MRMListTitle'])
	print(L['MRMListFlyingTitle'])
	if #MountRandomMount_SavedTable['flying'] == 0 then
		print(L['MRMNoFlyingMounts'])
	else
		for i = 1, #MountRandomMount_SavedTable['flying'] do
			print("   "..i..". "..GetSpellInfo(MountRandomMount_SavedTable['flying'][i]))
		end
	end
	print(" ")
	print(L['MRMListLandTitle'])
	if #MountRandomMount_SavedTable['ground'] == 0 then
		print(L['MRMNoLandMounts'])
	else
		for i = 1, #MountRandomMount_SavedTable['ground'] do
			print("   "..i..". "..GetSpellInfo(MountRandomMount_SavedTable['ground'][i]))
		end
	end
end


SLASH_RANDOMMOUNT1 = "/rdm"
SlashCmdList["RANDOMMOUNT"] = function(msg)
	if msg then
		local command2 = string.lower(msg);
		local command, rest2 = command2:match("^(%S*)%s*(.-)$")
		local rest
		local ibeg, _= string.find(rest2, "%[")
		local _, iend = string.find(rest2, "%]")
		if ibeg ~= nil and iend ~= nil then
			rest = string.sub(rest2, ibeg+1, (iend -1))
		end
		if command == L['MRMRandom'] then
			MountRandomMount:MountRandom()
		elseif command == L['MRMLandOnly'] then
			MountRandomMount:LandOnly()
		elseif command == L['MRMAdd'] then
			if rest ~= nil then
				MountRandomMount:add(rest)
			else
				print(L['MRMBracketERROR'])
			end
		elseif command == L['MRMRemove'] then
			if rest ~= nil then
				MountRandomMount:remove(rest)
			else
				print(L['MRMBracketERROR'])
			end
		elseif command == L['MRMList'] then
			MountRandomMount:list()
		elseif command == L['MRMGui'] then
				InterfaceOptionsFrame_OpenToCategory('MountRandomMount')
				return
		elseif command == L['MRMCatInside'] then
			local localizedClass, englishClass = UnitClass("player")
			if localizedClass == L['MRMDruid'] then
				if MountRandomMount_SavedTable.MRMDruid_CatInside then
					print(L['MRMCatInsideFalse'])
					MountRandomMount_SavedTable.MRMDruid_CatInside = false
				else
					print(L['MRMCatInsideTrue'])
					MountRandomMount_SavedTable.MRMDruid_CatInside = true
				end
			else
				print(L['MRMNotADruid'])
			end
		elseif command == "debug" then
			if MRMDebug then
				MRMDebug = false
				print("Debugging printing off.")
			else
				MRMDebug = true
				print("Debugging printing on.")
			end
		else
			print(L['MRMCommands'])
		end
	end
end